#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl -w
use strict;
use PureMessage::Manager::Lang;
use PureMessage::Enduser::Request;
use PureMessage::Enduser::Response;
use PureMessage::Enduser::UI::User;

my $REQUEST = new PureMessage::Enduser::Request;
my $r = $REQUEST->get_response('', stderr_to_stdout => 0);

# set language name space
PureMessage::Manager::Lang::set_namespace("EUUI/index");

# user object does data retrieval
my $user;
if (! $r->authorize_user) {
    $r->send();
    exit;
} else {
    $user = $r->user();
}

my %features = $user->get_features();
$r->errors($user, $0, 'get_features');

my $sid = $user->session_id();
my $quarantine = $features{'quarantine.messages'};
my $white_list = $features{'list.white'};
my $black_list = $features{'list.black'};
my $options = $features{'option.spam_optout'} && $features{'option.digest_optout'} && $features{'option.vacation'};

# set the language
my $lang = $user->language();
$r->errors($user, $0, 'language', 'get_language_error');

if ($quarantine) {
    $r->redirect("messages.cgi?message_type=blocked");
    exit;
} elsif ($white_list) {
    $r->redirect("senders.cgi?sender_type=approved");
    exit;
} elsif ($black_list) {
    $r->redirect("senders.cgi?sender_type=blocked");
    exit;
} elsif ($options) {
    $r->redirect("options.cgi");
    exit;
} else {
    $r->add_part("<p>" . lang_text_utf8($lang, 'no_features_enabled') . "</p>\n");
}

$r->send;
