#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl -w
use strict;
use Mail::Address;
use PureMessage::Manager::Lang;
use PureMessage::Enduser::Request qw(%in);
use PureMessage::Enduser::Response;
use PureMessage::Enduser::UI::User;
use PureMessage::Config qw(%config);
use PureMessage::Enduser::Auth::DomainVerify qw(verifyDomainName);

my $REQUEST = new PureMessage::Enduser::Request;
my $r = $REQUEST->get_response('', nofeatures => 1, stderr_to_stdout => 0, 'titlebar-only' => 1);

# set language name space
PureMessage::Manager::Lang::set_namespace("EUUI/send_auth");

# set language
my $lang = $config{'language'};

$r->{debug} =0;

my $send_auth = $r->new_tmpl("send_auth.html");
$send_auth->param('message_send_auth' => lang_text_utf8($lang, 'message_send_auth'),
		  'action_email' => lang_text_utf8($lang, 'action_email'),
		  'button_send_auth' => lang_text_utf8($lang, 'button_send_auth'),
		  );


if ((exists $in{'send_auth'}) && ($in{'send_auth'} eq lang_text_utf8($lang, 'button_send_auth'))) {
    if ((exists $in{'auth_email'}) && ($in{'auth_email'} ne '')) {
	my ($new_add) = Mail::Address->parse($in{'auth_email'});
	# TODO - fix error checking
	if (! $new_add) {
	    print STDERR "Invalid email address: " . $in{'auth_email'} . "\n";
	}
	my $auth_add = $new_add->format();
	if (! $auth_add) {
	    $send_auth->param('invalid_email' => lang_text_utf8($lang, 'invalid_email', $in{'auth_email'}));
	}
	if (! verifyDomainName($in{'auth_email'})){
        $send_auth->param('auth_error' => lang_text_utf8($lang, 'auth_error', $in{'auth_email'}));
        goto LAST;
    }
	my $user = $r->user(create => 1);
	if ($user->email_credentials($auth_add)) {
	    $send_auth->param('auth_success' => lang_text_utf8($lang, 'auth_success', $auth_add),
			      'auth_instructions' => lang_text_utf8($lang, 'auth_instructions'),
			      );
	} else {
            if ($user->error()) {
                my $x = $user->extended_error();
                if ($x and defined( $x->{'authorize_invalid_identity'})) {
                  $r->raise_error($x->{'authorize_invalid_identity'}->{errorstr});
                  print STDERR "error sending authorization to '$auth_add': $x->{authorize_invalid_identity}->{errorstr}\n";
                  $send_auth->param('query' => 1,'email' => $auth_add);
                  $user->handle_error('authorize_invalid_identity');
                } else {
                  print STDERR "error sending authorization to '$in{auth_email}': " . $user->error() . "\n";
	          $send_auth->param('auth_error' => lang_text_utf8($lang, 'auth_error'));
                  $user->handle_error();
                }
            } else {
              # not sure what happened so show a generic error
	      $send_auth->param('auth_error' => lang_text_utf8($lang, 'auth_error'));
            }
	}
    }
} else {
    $send_auth->param('query' => 1);
}
LAST:
$r->add_part($send_auth);
$r->send;
